#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Coppia contenente k-gramma e conteggio delle sue occorrenze

struct Pair{
 char *kgram;  //   puntatore al prima k-gramma
 int occ;      //   numero occorrenze
};

int K; 	       //   lunghezza dei k-grammi


// funzione confronto lessicografico tra k-grammi

int comp_kgrams(char *a, char *b){

 int i;
 for (i=0; i< (K-1) && (a[i] == b[i]); i++);
 
 return (a[i]-b[i]);
}

// confronto tra coppie

int comp_pair(const void *_a, const void *_b) {

  struct Pair *a = (struct Pair*)_a;
  struct Pair *b = (struct Pair*)_b;

  if (a->occ != b->occ) 
     return (b->occ - a->occ);
  else 
     return comp_kgrams(a->kgram, b->kgram);

}

int main(){

 char s[1000];
 struct Pair* kfreq; 
 int T;
 int len, i, j,distinct;

 // lettura dei parametri in input
 scanf("%d",&K);
 scanf("%d",&T);
 scanf("%s",s);
 len = strlen(s);

 if (len < K) return;

 // costruzione della mappa k-grammi - occorrenze (tempo O(len ^ 2) )

  distinct = 0;
  kfreq = malloc((len-K+1)*sizeof(struct Pair));

 for (i=0; i<= len-K; i++) {
  // determina se è la prima occorrenza...
  for (j=0; j<i; j++) 
   if (comp_kgrams(s+i, s+j) == 0) break;

  // ... in caso affermativo:     
  if (j == i)  {
   kfreq[distinct].kgram = s+i; 
   kfreq[distinct].occ = 0;

   for (j=0; j <= len-K; j++)
    if (comp_kgrams(s+i, s+j) == 0)                   
      kfreq[distinct].occ++;

   distinct ++; 
  }
}
 
 // stampa i primi T k-grammi con maggior valore di occ 


 qsort(kfreq, distinct, sizeof(struct Pair), comp_pair);	// ordina per occ decrescente

 for (i=0; i< distinct && i < T; i++){
     fwrite(kfreq[i].kgram, sizeof(char), K, stdout);
     printf(" %d\n", kfreq[i].occ);
 }


}
